import subprocess


class Operator:

    # Public

    def __init__(self, call=None, *args, shell=False, **kwargs):
        if call is None:
            call = subprocess.call
        self.__call = call
        self.__args = args
        self.__shell = shell
        self.__kwargs = kwargs

    def __call__(self, argv):
        if self.__shell:
            argv = ' '.join(argv)
        result = self.__call(
            argv, *self.__args,
            shell=self.__shell, **self.__kwargs)
        return result
