from .placeholder import Placeholder


class option(Placeholder):

    # Public

    def __init__(self, placeholders, options, name, *, prefix=['-', '--']):
        self.__placeholders = placeholders
        self.__options = options
        self.__name = name
        self.__prefix = prefix

    def __call__(self):
        argv = []
        value = self.__options.pop(self.__name)
        if value is not False:
            argv += self.__translate_name(self.__name, prefix=self.__prefix)
            if value is not True:
                argv += self.__translate_value(value)
        return argv

    # Private

    def __translate_name(self, name, *, prefix):
        argv = []
        name = name.replace('_', '-')
        try:
            name = prefix + name
        except TypeError:
            if len(name) == 1:
                name = prefix[0] + name
            else:
                name = prefix[1] + name
        argv.append(name)
        return argv

    def __translate_value(self, value):
        argv = []
        if not isinstance(value, list):
            value = [value]
        for item in value:
            item = str(item)
            argv.append(item)
        return argv
